<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Combobox.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Combobox.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(["underscore", "jquery", "uweaver/lang", 'uweaver/dom', "uweaver/widget/Widget", 'uweaver/data/Collection',
    'uweaver/data/Model', 'uweaver/widget/Popup', 'uweaver/widget/Tooltips', 'uweaver/exception/Violation',
    'text!./tpl/combobox/Suggestion.html'], function(_, $, lang, dom, Widget, Collection, Model, Popup, Tooltips, Violation, tplSuggestion) {
    var declare = lang.declare;
    var Base = Widget;
    var CACHELIMIT = 500;


    /**
     * A Combobox visualizes a combination of a drop-down list or list box and a single-line editable textbox,
     * allowing the user to either type a value directly or select a value from the list.
     *
     * ##### JavaScript
     * ```javascript
     * var Products = declare(Collection, {
     *      resource: 'products'
     * });
     * var products = new Products();
     *
     * var combobox = new Combobox({
     *      el: $('[name=combobox]')
     * }).render();
     *
     * combobox.data(products);
     *
     * combobox.valueField('id');
     * combobox.displayField('name');
     *
     * combobox.value("rose,daisy");
     *
     * expect(combobox.value()).to.eq("rose,daisy");
     *
     * ```
     * ##### HTML
     * + div: required.
     *
     * ```html
     * &lt;div name="combobox" class="form-control" style="width: 200px;>&lt;/div>
     * ```
     *
     * ##### Events:
     * + 'change' - [value()]{@link Combobox#value}
     *
     * @constructor Combobox
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {Collection} [config.data=new Collection()] - The collection to provide selection options data.
     * @param {String} [config.valueField='value'] - Specifies the value field.
     * @param {String} [config.displayField='title'] - Specifies the display field.
     * @param {Boolean} [config.readonly=false] - Specifies that an input field is read-only.
     * @param {Boolean} [config.required=false] - Specifies that an input field must be filled out.
     * @param {Boolean} [config.disabled=false] - Specifies that an &lt;input> element should be disabled.
     * @param {Boolean} [config.maxLength] - Specifies the maximum number of selections allowed.
     * @param {Boolean} [config.minLength] - Specifies the minimum number of selections required.
     * @param {Boolean} [config.manual=false] - Setting manual to true will allow users to type new values not in the options.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            valueField: 'value',
            displayField: 'title'
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        var tooltips = new Tooltips({
            target: this
        }).render();

        this._tooltips = tooltips;

        (cfg.data) ? this.data(cfg.data) : this.data(new Collection());

        this._value = [];
        this._valueField = cfg.valueField;
        this._displayField = cfg.displayField;
        this._manual = cfg.manual;


        var anchors = this._anchors;
        this.addClass('uw-combobox');
        this.$el.append($("&lt;input type='search' maxlength='10' size='10'>"));
        if(anchors.$input) anchors.$input.off();
        anchors.$input = this.$("input");
        anchors.$input.on("keyup", _.bind(onKeyUp, this));
        anchors.$input.on("keydown", _.bind(onKeyDown, this));

        this._suggestion = new Suggestion();
        this.listenTo(this._suggestion, 'select', _.bind(onSelect, this));
        this._popup = new Popup().render();
        this._popup.content(this._suggestion);
        this.$el.on('click', _.bind(onClick, this));

        (cfg.required!==undefined) &amp;&amp; this.required(cfg.required);
        (cfg.maxLength!==undefined) &amp;&amp; this.maxLength(cfg.maxLength);
        (cfg.minLength!==undefined) &amp;&amp; this.minLength(cfg.minLength);
        (cfg.readonly!==undefined) &amp;&amp; this.readonly(cfg.readonly);
        (cfg.disabled!==undefined) &amp;&amp; this.disabled(cfg.disabled);

        this.readonly() &amp;&amp; this.readonly(true);
        this.disabled() &amp;&amp; this.disabled(true);

        this.clearValidation();
    }

    function render(options) {

        var defaults = {
            hidden: false
        };
        options || (options = {});
        _.defaults(options, defaults);

        this.$('div').remove();
        _.each(this._value, function(value) {
            lookup.call(this, value);
            addTag.call(this, value);
        }, this);

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function onKeyUp(event) {
        var $input = this._anchors.$input;
        var value = $input.val();

        if(/(;|,| )$/.test(value)) {
            push.call(this, value.substr(0, value.length-1));
            $input.val('');
            return false;
        }

        var keyword = value;
        suggest.call(this, keyword);
    }


    function onKeyDown(event) {
        var $input = this._anchors.$input;
        var value = $input.val();

        if(event.which===8) {
            // When the backspace key is pressed.
            if(value.length===0) {
                // Remove the last added choice if no keyword.
                pop.call(this, _.last(this._value));
                return;
            } else {
                // suggest if there is keyword.
                var keyword = value.substring(0, value.length-1);
                suggest.call(this, keyword);
            }
        } else if(event.which===40) {
            // suggest when the down arrow key is pressed.
            var keyword = $input.val();
            suggest.call(this, keyword);
        }
    }

    function push(value) {

        if(!value||value.length===0) return;

        if(this._value.length>=this.maxLength()) return;

        if(_.contains(this._value, value)) return;

        if(!this._manual&amp;&amp;(find.call(this, value)===undefined)) return;

        this._value.push(value);

        addTag.call(this, value);

        this.validate() &amp;&amp; this.change();
    }

    function addTag(value) {
        var $input = this._anchors.$input;
        var item = find.call(this, value);
        var title = item ? item.get(this._displayField) : value;

        var $tag = $("&lt;div>&lt;span>x&lt;/span>" + title + "&lt;/div>");
        $tag.data('value', value);
        $input.before($tag);

        $tag.find('span').one('click', _.bind(onRemoverClick, this));
    }

    function onRemoverClick(event) {
        if(this.disabled() || this.readonly()) return;
        var $tag = $(event.target.parentElement);
        var value = $tag.data('value');
        pop.call(this, value);

    }

    function removeTag(value) {
        var index = _.indexOf(this._value, value);
        this.$('div').eq(index).remove();
    }

    function find(value) {
        return this._data.find(function(item) {
            return (item.get(this._valueField)===value)||(item.get(this._displayField)===value);
        }, this);
    }

    function pop(value) {
        removeTag.call(this, value);
        this._value = _.without(this._value, value);

        this.validate() &amp;&amp; this.change();
    }

    function change() {
        var event = {
            data: this.value(),
            context: this,
            source: this
        };

        this.trigger("change", event);
    }

    function suggest(keyword) {
        var data = this._data;

        if(data.size()&lt;=data.limit()) {
            lookup.call(this, keyword);
        }

        keyword = keyword.toUpperCase();
        var items = data.filter(function(item) {
            var value = item.get(this._valueField);
            if(value &amp;&amp; (value===keyword || value.toUpperCase().indexOf(keyword)!==-1)) return true;
            value = item.get(this._displayField);
            if(value &amp;&amp; (value===keyword || value.toUpperCase().indexOf(keyword)!==-1)) return true;
            return false;
        }, this);

        items = _.map(items, function(item){
            return {
                title: item.get(this._displayField),
                value: item.get(this._valueField)
            }
        }, this);

        this._suggestion.data(items);
        this._suggestion.outerWidth(this.outerWidth(true), true);
        this._popup.show({
            positionTo: this
        });
    }

    function lookup(keyword) {
        if(_.isFunction(this._lookup)) {
            this._lookup(keyword);
            return;
        }

        var data = this._data;

        if(data.size()>0 &amp;&amp; data.size()&lt;=CACHELIMIT) return;

        /**
         * @todo preserve the collection's filters.
         */
        if(data.filters()!==[]) return;
        
        data.fetch({
            filters: [{
                property: this._valueField,
                value: keyword,
                operator: "LIKE"
            }],
            sorters: [{
                property: this._displayField,
                direction: "ASC"
            }],
            limit: CACHELIMIT,
            conjunction: "OR",
            async: false
        });
    }

    function onSelect(event) {
        var value = event.data;

        this._anchors.$input.val("");

        _.contains(this._value, value) ? pop.call(this, value) : push.call(this, value);

    }

    function onClick(event) {
        if(this.disabled() || this.readonly()) return;
        var $input = this._anchors.$input;
        $input.focus();
        var keyword = $input.val();
        suggest.call(this, keyword);
    }

    /**
     * Get or set the data.
     *
     * @memberof Combobox#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @returns {Collection}
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {};

        _.defaults(options, defaults);

        if(items instanceof Collection) {
            this._data = items;
        } else if(_.isArray(items)) {
            this._data = new Collection();
            _.each(items, function(item) {
                var model;
                if(_.isObject(item)) {
                    model = new Model(item);
                } else {
                    model = new Model({
                        value: item,
                        title: item
                    })
                }
                this._data.add(model);
            }, this);
        }

        if(this._data.size()===0 &amp;&amp; this._data.count()&lt;=CACHELIMIT) {
            this._data.fetch({
                async: false
            });
        }
        
        return this._data;
    }
    
    function valueField(field) {
        if(!field) return this._valueField;
        
        this._valueField = field;
    }
    
    function displayField(field) {
        if(!field) return this._displayField;

        this._displayField = field;
    }

    
    /**
     *
     * Get or set the value.
     *
     * @param {String|String[]} value
     * @returns {string|undefined}
     */
    function value(value, options) {
        options || (options = {});
        
        if(arguments.length===0) {
            return (this._value &amp;&amp; this._value.length>0) ? this._value.join() : null;
        }

        value || (value = []);

        _.isArray(value) || (value = value.split(','));

        if(_.difference(value, this._value).length==0) return;

        this._value = value;

        this.render();

        this.validate() &amp;&amp; (options.silent || this.change());
    }

    function clear() {
        this._value = [];
        this.render();
        this.clearValidation();
    }

    function name(name) {

        if(!name) return this.$el.attr('name');

        this.$el.attr('name', name);
    }

    function type() {
        var $input = this._$component;

        return $input.attr('type');
    }

    function size() {
        return this._value.length;
    }

    /**
     * @todo
     * @param hint
     * @returns {*}
     */
    function placeholder(hint) {
    }


    function clearValidation() {
        this._violations = [];
        this._tooltips.content("");
        this.removeClass('uw-border-warn');
    }

    function readonly(value) {
        if(arguments.length===0) return this.el.hasAttribute('readonly');

        value ? this.el.setAttribute('readonly', null) : this.el.removeAttribute('readonly');
        
        var $input = this._anchors.$input;
        $input.prop('disabled', value);
    }

    function required(value) {
        if(arguments.length===0) return this.el.hasAttribute('required');

        value ? this.el.setAttribute('required', null) : this.el.removeAttribute('required');
    }

    function disabled(value) {
        if(arguments.length===0) return this.el.hasAttribute('disabled');

        value ? this.el.setAttribute('disabled', null) : this.el.removeAttribute('disabled');

        var $input = this._anchors.$input;
        $input.prop('disabled', value);
    }

    function maxLength(value) {
        var $component = this.$el;
        if(arguments.length===0) return Number($component.attr('maxLength'));
        $component.attr('maxLength', value);
    }

    function minLength(value) {
        var $component = this.$el;
        if(arguments.length===0) return Number($component.attr('minLength'));
        $component.attr('minLength', value);
    }

    /**
     * Validate the value of the inputbox.
     */
    function validate() {
        var $control = this.$el;
        var validity = $control.prop('validity');
        var valid = true;

        this.clearValidation();

        (valid &amp;&amp; _.isObject(validity)) &amp;&amp; (valid = this.checkValidity());

        (valid &amp;&amp; this.useCustomType()) &amp;&amp; (valid = this.customValidate());

        return valid;
    }

    function checkValidity() {
        var $input = this.$el;
        var validity = $input.prop('validity');

        if(!validity.valid) {
            _.each(VALIDATIONERRORS, function(prop, error) {
                if(validity[error]) {
                    var parameters = [];
                    if(prop) {
                        parameters.push($input.prop(prop)||$input.attr(prop));
                    }
                    this.violate(new Violation({
                        properties: [this.name()],
                        error: error,
                        parameters: parameters
                    }));
                }
            }, this);

            var validationMessage = "";
            _.each(this._violations, function(violation) {
                validationMessage = validationMessage + '\n' + violation.toString();
            });
            $input.get(0).setCustomValidity(validationMessage);
        }


        return validity.valid;
    }

    function useCustomType() {
        return true;
    }

    function customValidate() {
        var valid = true;

        this.validateRequired() || (valid = false);
        this.validateMaxLength() || (valid = false);
        this.validateMinLength() || (valid = false);

        return valid;
    }

    function validateRequired() {
        if(!this.required()) return true;

        if(this.size()===0) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.VALUEMISSING
            }));
            return false;
        }

        return true;
    }

    function validateMaxLength() {
        if(!this.maxLength()) return true;

        if(this.size()>this.maxLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOLONG,
                parameters: [this.maxLength()]
            }));
            return false;
        }

        return true;
    }

    function validateMinLength() {
        if(!this.minLength()) return true;

        if(this.size()&lt;this.minLength()) {
            this.violate(new Violation({
                properties: [this.name()],
                error: Violation.Error.TOOSHORT,
                parameters: [this.minLength()]
            }));
            return false;
        }

        return true;
    }

    function violate(violation) {
        if(!violation) return;

        this._violations.push(violation);

        this.hasClass('uw-border-warn') || this.addClass('uw-border-warn');

        this._tooltips.append(violation.toString() + "&lt;br>");

        return violation;
    }


    function violations() {
        return this._violations;
    }

    function state(value) {
        if(arguments.length===0) return this._state;

        this._state = value.toUpperCase();

        this.readonlyState() &amp;&amp; this.readonly(_.contains(this.readonlyState().toUpperCase().split(","), this._state));
        this.disabledState() &amp;&amp; this.disabled(_.contains(this.disabledState().toUpperCase().split(","), this._state));
        this.hiddenState() &amp;&amp; _.contains(this.hiddenState().toUpperCase().split(","), this._state) ? this.hide() : this.show();
    }

    function readonlyState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-readonly-state');
        $input.attr('data-readonly-state', value);
    }

    function disabledState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-disabled-state');
        $input.attr('data-disabled-state', value);
    }

    function hiddenState(value) {
        var $input = this.$el;
        if(arguments.length===0) return $input.attr('data-hidden-state');
        $input.attr('data-hidden-state', value);
    }

    var Suggestion = declare(Widget, {
        initialize: function() {
            this.$el.html(_.template(tplSuggestion)(this));
        },
        render: function() {
            var $content = this.$('ul');
            $content.empty();
            _.each(this._data, function(datum) {
                var $item = $("&lt;li class='list-group-item'>" + datum.title + "&lt;/li>");
                $item.data('value', datum.value);
                $content.append($item);
            });
            var $items = this.$('li');

            $items.on('click', _.bind(this.onSelect, this));
        },
        data: function(items) {
            this._data = items;
            this.render();
        },
        onSelect: function(event) {
            var $item = $(event.target);

            this.trigger('select', {
                context: this,
                source: this,
                data: $item.data('value')
            });
        }
    }, {
        _data: []
    });

    var props = {
        _data: undefined,
        _value: undefined,
        _valueField: undefined,
        _displayField: undefined,
        _manual: undefined,
        _tooltips: undefined,
        _state: undefined
    };

    var Combobox = declare(Base, {
        initialize: initialize,
        render: render,
        value: value,
        clear: clear,
        size: size,
        change: change,
        data: data,
        valueField: valueField,
        displayField: displayField,
        name: name,
        type: type,
        placeholder: placeholder,
        validate: validate,
        violate: violate,
        violations: violations,
        checkValidity: checkValidity,
        useCustomType: useCustomType,
        customValidate: customValidate,
        clearValidation: clearValidation,
        validateRequired: validateRequired,
        validateMaxLength: validateMaxLength,
        validateMinLength: validateMinLength,
        readonly: readonly,
        required: required,
        disabled: disabled,
        maxLength: maxLength,
        minLength: minLength,
        state: state,
        readonlyState: readonlyState,
        disabledState: disabledState,
        hiddenState: hiddenState
    }, props);

    return Combobox ;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
